#include <cstdio>
#include <cstring>
#include <algorithm>
#include <stack>
#include <vector>
#include <string>
#include <cassert>
using namespace std;

char word[2][110];
char c[100010];
int K, N;
int diff[110];

vector<vector<int> > found[2];

int mod26(int a) {
	assert(a < 100);
	while(a >= 26) a-= 26;
	return a;
}

void wynajdz(int dlugosc, int a) {
	int m = strlen(word[a]);
	for(int i=0; i+m <= N; i++) {
		for(int j=0; j<dlugosc; j++) {
			diff[(i+j) % dlugosc] = (52 + c[i+j] - word[a][j] + 1) % 26; 
		}
		bool ok = true;
		for(int j=dlugosc; j<m; j++) {
			if (diff[(i+j) % dlugosc] != (52 + c[i+j] - word[a][j] + 1) % 26) {
				ok = false;
				break;
			} 
		}
		
		if (ok) {
			vector<int> tmp(diff, diff+dlugosc);
			found[a].push_back(tmp);
		}
	}
}

string wynik;
bool cokolwiek;

string generate(const vector<int>& cykl) {
	string res = "";
	int pos = 0;
	for(int i=0; i<N; i++) {
		res += char(mod26(c[i] - 'A' + 26 - cykl[pos] + 1) + 'A'); 
		pos++;
		if (pos == cykl.size()) pos = 0;
	}
	return res;
}

bool check(const vector<int>& cykl) {
	string lol = generate(cykl);
	if (cokolwiek) {
		if (lol != wynik){
			printf("ambiguous\n");
			printf("%s %s\n",lol.c_str(), wynik.c_str());
			return false;
		}	
	} else {
		cokolwiek = true;
		wynik = lol;
	}
	return true;
}

int main() {
	while(true) {
		cokolwiek = false;
		scanf("%d",&K);
		if (K == 0) return 0;
		
		scanf("%s %s %s", word[0], word[1], c);
		N = strlen(c);
		for(int dl = 1; dl <= K; dl++) {
			found[0].clear(); found[1].clear();
			wynajdz(dl, 0); wynajdz(dl, 1);
			
			sort(found[0].begin(), found[0].end());
			sort(found[1].begin(), found[1].end());
			
			int i = 0, j = 0;
			while(i < found[0].size() && j < found[1].size()) {
				if (found[0][i] == found[1][j]) {
					if (!check(found[0][i])) {
						goto end;
					}
					i++;
					j++;
				} else if (found[0][i] < found[1][j]) {
					i++;
				} else {
					j++;
				}
			}
		}
		
		if (cokolwiek) printf("WYNIK %s\n", wynik.c_str());
		else printf("impossible\n");
		end:;
	}
	return 0;
}
